#include <stdio.h>
#include <trace_user.h>
#include <trace_defs.h>
#include <spu_mfcio.h>

int main(unsigned long long speid, unsigned long long argp, unsigned long long envp)
{
	trace_payload_t pl;
	int local_value = -1;
	int usr_tag = 1;
	int usr_mask = 1 << usr_tag;

	printf("Hello world from SPE!\n");

	pl.word[0] = 1;
	trace_user_event(&pl);
	printf("An user event in SPE\n");

	trace_interval_p interval = trace_user_interval_entry();
	printf("An user interval in SPE\n");
	trace_user_interval_exit(interval, &pl);

	printf("The value before DMA in SPE is %d\n", local_value);
	mfc_get(&local_value, argp, sizeof(int), usr_tag, 0, 0);
	mfc_write_tag_mask(usr_mask);
	mfc_read_tag_status_all();

	printf("The value received in SPE is %d\n", local_value);
	local_value = 100;
	mfc_put(&local_value, argp, sizeof(int), usr_tag, 0, 0);
	mfc_write_tag_mask(usr_mask);
	mfc_read_tag_status_any();

	return 1;
}
